/*
  DXC Framework (http://dx-competition.org/)
  Copyright 2008 David Garcia

  The DXC Framework is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation, either version 3 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
  details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>
*/
#ifndef SCENARIO_LOADER_CONNECTOR
#define SCENARIO_LOADER_CONNECTOR

#include <DxcDefs.hpp>
#include <Connection/DxcConnectorImp.hpp>

namespace Dxc
{
class DXCAPI_EXPORT ScenarioLoaderConnector : public DxcConnectorImp
{
    friend class ConnectorFactory;

public:
    void initConnections();
    void sendMessage(const DxcData *);

private:
    ScenarioLoaderConnector(DxcCallback *);
    void acceptConnections();
    int sdsock_;
    int srsock_;
};
}

#endif
