/*
  DXC Framework (http://dx-competition.org/)
  Copyright 2008 David Garcia

  The DXC Framework is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation, either version 3 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
  details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>
*/
#include <DxcConfig.hpp>
#include <Connection/ScenarioRecorderConnector.hpp>

using namespace Dxc;

ScenarioRecorderConnector::ScenarioRecorderConnector(DxcCallback *cb)
        : DxcConnectorImp(cb), sdsock_(-1)
{
    initConnections();
    acceptConnections();
}

void ScenarioRecorderConnector::initConnections()
{
    connect("localhost", DxcConfig::getInstance()->getInt("SDS_SR_PORT"), &sdsock_);
}

void ScenarioRecorderConnector::sendMessage(const DxcData * msg)
{
    DxcConnectorImp::transmit(sdsock_, msg);
}

void ScenarioRecorderConnector::acceptConnections()
{
    DxcConnectorImp::acceptConnection(DxcConfig::getInstance()->getInt("SR_DA_PORT"), &dasock_);
    DxcConnectorImp::acceptConnection(DxcConfig::getInstance()->getInt("SR_SL_PORT"), &slsock_);
}
