/*
  DXC Framework (http://dx-competition.org/)
  Copyright 2008 David Garcia
  
  The DXC Framework is free software: you can redistribute it and/or modify it 
  under the terms of the GNU Lesser General Public License as published by the 
  Free Software Foundation, either version 3 of the License, or (at your 
  option) any later version. 

  This program is distributed in the hope that it will be useful, but WITHOUT 
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
  details. 

  You should have received a copy of the GNU Lesser General Public License 
  along with this program. If not, see <http://www.gnu.org/licenses/> 
 */
package org.dxc.api.connection;

import java.net.ServerSocket;
import java.net.Socket;

import org.dxc.api.DxcCallback;

class ServerSocketMonitor implements Runnable {
    private ServerSocket s;

    private DxcCallback c;

    private ConnectionCallback cc;

    public ServerSocketMonitor(DxcCallback c, ServerSocket s,
            ConnectionCallback cc) {
        this.s = s;
        this.c = c;
        this.cc = cc;
    }

    public void run() {
        try {
            Socket ns = s.accept();
            if (cc != null)
                cc.connectionMade(ns, s.getLocalPort());
            new Thread(new StreamListener(c, ns.getInputStream())).start();
        } catch (Exception ex) {
            System.out.append(ex.toString() + " " + ex.getMessage());
        }
    }
}