/*
  DXC Framework (http://dx-competition.org/)
  Copyright 2008 David Garcia
  
  The DXC Framework is free software: you can redistribute it and/or modify it 
  under the terms of the GNU Lesser General Public License as published by the 
  Free Software Foundation, either version 3 of the License, or (at your 
  option) any later version. 

  This program is distributed in the hope that it will be useful, but WITHOUT 
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
  details. 

  You should have received a copy of the GNU Lesser General Public License 
  along with this program. If not, see <http://www.gnu.org/licenses/> 
 */
package org.dxc.api.datatypes;

import java.io.PrintStream;

/**
 * Abstract interface for values that can be of various concrete datatypes.
 * 
 * Value is the superclass of all the basic datatypes that can be referred to by
 * DxcData, such as boolean, integer, real, or string. The abstraction is
 * provided so that data of various kinds can be supplied in a uniform way, eg.
 * for sensor values and command values.
 */
public interface Value {
    /**
     * Print the value to an output stream.
     */
    public PrintStream put(PrintStream out);
}