/*
  DXC Framework (http://dx-competition.org/)
  Copyright 2008 David Garcia

  The DXC Framework is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation, either version 3 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
  details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>
*/
#ifndef DXC_DA_CONFIG_H
#define DXC_DA_CONFIG_H

#include <map>
#include <vector>
#include <string>

using namespace std;

namespace Dxc
{

class DAConfig
{
public:
    DAConfig(string configFile);

    string getName() const;
    string getDirectory() const;
    string getBinName() const;
    string getJavaClass() const;
    string getArgs(const string& system) const;
    string getPlatform() const;

    vector<string> getSupportedSystems() const;

private:
    string name_;
    string directory_;
    string binName_;
    string javaClass_;
    string platform_;

    map<string, string> systemToArgs_;
};

}

#endif
