/*
  DXC Framework (http://dx-competition.org/)
  Copyright 2008 David Garcia

  The DXC Framework is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation, either version 3 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
  details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>
*/
#ifndef DXC_JAVALOADER_HPP
#define DXC_JAVALOADER_HPP

#include <string>
#include <vector>
#include <ProcessLoader.hpp>
#include <ProcessFactory.hpp>

namespace Dxc
{

class JavaLoader : public ProcessLoader
{
public:
    JavaLoader(const std::string& jarName,
               const std::string& className,
               const std::string& path,
               const std::string& args);

    void start();
    bool isRunning();
    void terminate();
    unsigned long getCpuTime();
    unsigned long getPeakMemoryUsage();
    virtual bool timedWait(long);

    ~JavaLoader();

private:
    string classpath_, className_, args_;
    ProcessLoader* javavm_;
};

}

#endif
