/*
  DXC Framework (http://dx-competition.org/)
  Copyright 2008 David Garcia

  The DXC Framework is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation, either version 3 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
  details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>
*/
#include <assert.h>
#include <ScenarioTracker.hpp>
#include <DxcCallback.hpp>

using namespace Dxc;
using namespace std;

class SLCallback : public DxcCallback
{
public:
    SLCallback(ScenarioTracker* s) : s_(s) {};

    void processData(const DxcData * msg)
    {
        if (string(typeid(*msg).name()) == string(typeid(ScenarioStatusData).name()))
        {
            const ScenarioStatusData* stat = dynamic_cast<const ScenarioStatusData *>(msg);

            string status = stat->getStatus();

            if (status == ScenarioStatusData::SDS_AWAITING_DA)
            {
                s_->updateStatus(ScenarioTracker::ST_AWAITING_DA);
            }
            else if (status == ScenarioStatusData::STARTED)
            {
                s_->updateStatus(ScenarioTracker::ST_STARTED);
            }
            else if (status == ScenarioStatusData::SDS_ENDED)
            {
                s_->updateStatus(ScenarioTracker::ST_ENDED);
            }
        }
        else if (typeid(msg).name() == typeid(ErrorData).name())
        {
            s_->updateStatus(ScenarioTracker::ST_ERROR);
            cout << msg;
        }
    };
private:
    ScenarioTracker* s_;
};
